//+------------------------------------------------------------------+
//|                               Sampe01_GetDiskSerialNumber_EA.mq4 |
//|                             Copyright (C) 1999-2015, CODEWISE CC |
//|                                              anton.nel@gmail.com |
//|                         Skype instant messenger: antonyannicknel |
//|                           https://login.mql5.com/en/users/ROMAN5 |
//+------------------------------------------------------------------+
#property copyright "Copyright (C) 1999-2015, CODEWISE CC"
#property link      "anton.nel@gmail.com"
#property version   "1.00"
#property strict

#import "kernel32.dll"
   int lstrlenA(int);
   void RtlMoveMemory(uchar & arr[], int, int);
   int LocalFree(int); // May need to be changed depending on how the DLL allocates memory
#import

#import "GetDiskSerialNumber.dll"
   int Add(int left, int right);
   int Test();
   int DiskSerialNo();
#import

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   int checksum = Add(1,25);
   Print("GetDiskSerialNumber.dll Checksum Add(1 + 25) = " + IntegerToString(checksum)); // To check if this DLL is working probably.
   if (checksum == 26) 
   {
      // Call the DLL function and get its block of string memory as an int pointer to the
      // memory rather than as a string 
      int ptrStringMemory = Test();
      Print("TestFox: ",mql4_ansi2unicode(ptrStringMemory, false));
      
      ptrStringMemory = DiskSerialNo();
      Print("DiskSerialNumber: ",mql4_ansi2unicode(ptrStringMemory, false));

      //--- create timer
      EventSetTimer(60);
   }   

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   //--- destroy timer
   EventKillTimer();
      
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{

}
//+------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//| Lovely function that helps us to get ANSI strings from DLLs to our UNICODE |
//| format                                                                     |
//| http://forum.mql4.com/60708                                                |
//+----------------------------------------------------------------------------+
string mql4_ansi2unicode(int _ptrStringMemory, bool bDebug)
{
   if (_ptrStringMemory == 0)
   {
      return ("");
   }
   else
   {
      if (bDebug) Print("Debug #1");
      int szString = lstrlenA(_ptrStringMemory);
      if (bDebug) Print("Debug #2...szString=",szString);
      uchar ucValue[];
      if (bDebug) Print("Debug #3");
      ArrayResize(ucValue, szString + 1);
      if (bDebug) Print("Debug #4");
      RtlMoveMemory(ucValue, _ptrStringMemory, szString + 1);
      if (bDebug) Print("Debug #5");
      string str = CharArrayToString(ucValue);
      if (bDebug) Print("Debug #6...str=",str);
      LocalFree(_ptrStringMemory);
      if (bDebug) Print("Debug #7");
      return (str);
   }
}